function y=BcXnYnZn(u);

% u est la vaiable  4 composantes:
%	u(1) le temps orbital
%	u(2:4) le champ magntique en repre orbital

% Le rsultat calcule les composantes du champ de consigne pour une attitude fixe dans XnYnZn
% avec:
%	x suivant Xn
%	y suivant -Y
% 	z suivant -Zn*

% *******************************************************************************************

global H jour vitesse_rotation inclinaison

tps=u(1);     % Temps orbital ou temps de la simulation
BXYZ=u(2:4);

% ************************  Passage XYZ<-->  XnYnZn  *****************************

angle=vitesse_rotation*tps;                                   % Mouvement orbital

% Matrice de passage de XYZ  XnYnZn

Pmat=[-sin(angle) cos(inclinaison)*cos(angle) sin(inclinaison)*cos(angle)
           0 -sin(inclinaison) cos(inclinaison)
                  cos(angle) cos(inclinaison)*sin(angle) sin(inclinaison)*sin(angle)];


% **********************  Passage  XcYcZc <--> XnYnZn    **************************

PXnYnZn2XYZ=inv(Pmat);

% Xc=-Xn     Yc=-Y    Zc=-Zn*

PXcYcZc2XnYnZn=[-1 0 0
                  0 sin(inclinaison) -cos(inclinaison)
                      0 -cos(inclinaison) -sin(inclinaison)];

% **************************  Composantes de Bc dans XYZ *************************

y=PXcYcZc2XnYnZn*PXnYnZn2XYZ*BXYZ;

end       % fin programme