function y=SunitXYZ(u);

% ***********************************************************************
% La connaissance de H et jour, dans l'espace de travail est indispensable
% ***********************************************************************

global H jour vitesse_rotation inclinaison periode_orbitale rayon_orbital

tps=u;     % Temps orbital ou temps de la simulation

% Fonction qui retourne le vecteur unitaire soleil Us en axes orbitaux XYZ

% u est le temps comme vecteur d'entre, celui de la simulation 
%	- H heure au noeud ascendant
%	- jour est le jour de l'anne civile
%	- tps est le temps orbital mesur depuis le passage au noeud acendant

% ********************************  Dans XnYnZn  *************************************

% Unitaire soleil

teta=15*(12-H)*pi/180;                                        % Longitude nodale du soleil ( / Xn ), en radians

delta=23.45*sin(2*pi/365*(284+jour))*pi/180;                  % Dclinaison en radians formule de Fletcher

Us=[cos(delta)*cos(teta) cos(delta)*sin(teta) sin(delta)];    % Us en axes XnYnZn

angle=vitesse_rotation*tps;                                   % Mouvement orbital

% Matrice de passage de XYZ  XnYnZn

Pmat=[-sin(angle) cos(inclinaison)*cos(angle) sin(inclinaison)*cos(angle)
           0 -sin(inclinaison) cos(inclinaison)
                  cos(angle) cos(inclinaison)*sin(angle) sin(inclinaison)*sin(angle)];

% Composantes unitaire soleil dans XYZ


y=Pmat*Us';                    


end    % Fin programme


